#ifndef REGALLOC_H
#define REGALLOC_H

#include <string>
#include <stack>
#include "stack.h"

using namespace std;

enum
{
    LEFT_OPERAND,
    RIGHT_OPERAND
};

enum{
    _GLOBAL,
    _LOCAL
};

enum
{
    VARIABLE,
    REGISTER,
    USED,
    TYPE,
    REG
};

class RegisterAllocator
{
    public:

        RegisterAllocator();
        ~RegisterAllocator();

        /**
         * Gets a register available.
         * Writes the assembly for the allocation.
         * @varName name of variable that needs a register
         */
        string Get_Register(string varName, string type);
        void Free_Register(string varName);

        // Tell register allocator we're looking for either
        // left or right operand
        void findLeftOp();
        void findRightOp();

        // Get left expression operand
        string getLeftOp();
        // Get right expression operand
        string getRightOp();

        string getLastRegister();

        void setOperand(int index, bool array=false);
        void setArrayFlag(bool _array);

        void Free_Constants();
        void Free_Temps();

        void spill();

    private:
        string register_table[32][3];
        string register_names[32];

        stack<int> findOpHistory;
        string leftOperand;
        string rightOperand;

        bool findOp;
        string lastRegister;

        int arrayIndex;
        bool arrayFlag;

};

#endif
