#include "stack.h"

Stack::Stack()
{
    root = NULL;
    top = NULL;
    level = 0;
}

Stack::~Stack()
{
}

bool Stack::empty()
{
    return (root==NULL);
}

void Stack::push()
{
    ++level;
    if (root == NULL)
    {
        root = new rbtree();
        top = root;
    }
    else 
    {
        rbtree * temp = new rbtree();
        top->next = temp;
        temp->previous = top;
        top = temp;				
    }
}

//void Stack::insert(int v, string name)
node* Stack::insert(int v, string name, int type)
{
    if (empty()) 
    {
        root = new rbtree();
        top = root;
        return root->insert(v, name, type);
        //root->insert(v, name);
    }
    else
    {
        return top->insert(v, name, type);
        //top->insert(v, name);
    }
}

node* Stack::insert(node *_node)
{
    if (empty()) 
    {
        root = new rbtree();
        top = root;
        return root->insert(_node);
    }
    else
    {
        return top->insert(_node);
    }
}

node* Stack::search(string n, int &l)
{
    if (empty())
    {
        printf("stack is empty!!! Cannot search.\n");
        return NULL;
    }

    l = level;

    rbtree * temp = top;
    node * tempNode = NULL;
    bool found = false;
    while (!found && temp!=NULL)
    {
        tempNode = temp->search(n);
        if (tempNode != NULL)
        {
            found = true;
            return tempNode;
        }
        temp = temp->previous;
        --l;
    }

    return tempNode;
}

rbtree* Stack::pop()
{
    if (level > 0) 
        --level;

    if (root == NULL) return NULL;

    //IF THERE IS ONLY ONE LEVEL
    if (root->next == NULL && root->previous == NULL) 
    {
        root = NULL;
        return top;
    }
    else
    {
        rbtree * temp = top;
        top = top->previous;
        top->next = NULL;
        temp->previous = NULL;
        return temp;
    }
}

void Stack::pop_delete()
{
    if ( !empty() )
    {
        rbtree * temp = pop();
        temp->clear();
    }
}


int Stack::getLevel()
{
    return level;
}

void Stack::clear()
{
    rbtree * temp;
    while (!empty())
    {
        temp = top;
        top = top->previous;
        //if last tree
        if (top == NULL) root = NULL;
        temp->clear();
    }
    root = top = NULL;
}

void Stack::dump(FILE *f)
{
    rbtree * temp = top;
    int l = level;
    fprintf(f, "\n****************************************\n");
    fprintf(f, "Symbol TableDump");
    fprintf(f, "\n****************************************\n");
    while (temp!=NULL)
    {
	fprintf(f, "----------------------------------------\n");
	fprintf(f, "Level: %d\n",l+1);
        temp->dump(l, f);
	fprintf(f, "\n");
        --l;
        temp = temp->previous;
    }
}

void Stack::show()
{
    rbtree* temp = root;
    if (temp == NULL) 
    {
        printf("empty stack\n");
        return;
    }
    else {
        do {
            temp->showTree();
            temp = temp->next;
        } while (temp != NULL);
    }
}
